/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : April, 1997                                                    */
/* File Name : FacilitySchedule.h                                        */
/*************************************************************************/
/*************************************************************************/

#ifndef _FacilitySchedule_h
#define _FacilitySchedule_h

#include "Operation.h"

class  FacilitySchedule
{  private :
     int AvailableTime;
     Operation *PairList;
     int NumOfPairs;
     int pairIndex;

   protected:
     int debug;

   public :

     ~FacilitySchedule();

     FacilitySchedule();

     FacilitySchedule(const FacilitySchedule&);

     FacilitySchedule(int);

     void addOperation(Operation,int);

     Operation * getOperationWithIndex(int);

     getTime(Operation);

     getStartTime(Operation);

     getStartTimeOpWithIndx(int);

     getEndTime(Operation);

     getEndTimeOpWithIndx(int);

     getFirstEmptySlot();

     getNumberOfOperations() const;

     void print();

     FacilitySchedule operator =(const FacilitySchedule &RHSPair);

     operator ==(const FacilitySchedule &RHSPair);

     friend ostream & operator <<(ostream &os, const FacilitySchedule & sc);

     void swapJobs(int,int);
     void swapJobsOrder(int,int);

     void debugOn();
     void debugOff();
};// end of class  FacilitySchedule

#endif
